﻿Public Class DebugData

    Private Shared _DebugMultiAction As KeyBinding.Actions.Button.MultiAction
    Public Shared ReadOnly Property DebugMultiAction As KeyBinding.Actions.Button.MultiAction
        Get
            If Not IsInitialized Then
                Initialize()
            End If
            Return _DebugMultiAction
        End Get
    End Property

    Private Shared _DebugConfigurations As KeyBinding.Configurations.KeyBindingConfiguration()
    Public Shared ReadOnly Property DebugConfigurations As KeyBinding.Configurations.KeyBindingConfiguration()
        Get
            If Not IsInitialized Then
                Initialize()
            End If
            Return _DebugConfigurations
        End Get
    End Property

    Private Shared _DebugGamepads As GamepadData.Gamepad()
    Public Shared ReadOnly Property DebugGamepads As GamepadData.Gamepad()
        Get
            If Not IsInitialized Then
                Initialize()
            End If
            Return _DebugGamepads
        End Get
    End Property

    Private Shared IsInitialized As Boolean = False

    Private Shared Sub Initialize()
        Dim Connections As New List(Of Action)

        _DebugGamepads = _
        {
           New GamepadData.Gamepad(GamepadData.PlayerNumber.One) With {.IsActive = True}.ButAlso(Sub(o2) Connections.Add(Sub() o2.Configuration = _DebugConfigurations(0))), _
           New GamepadData.Gamepad(GamepadData.PlayerNumber.Two) With {.IsActive = True}.ButAlso(Sub(o2) Connections.Add(Sub() o2.Configuration = _DebugConfigurations(1))), _
           New GamepadData.Gamepad(GamepadData.PlayerNumber.Three) With {.IsActive = False}, _
           New GamepadData.Gamepad(GamepadData.PlayerNumber.Four) With {.IsActive = False}
        }

        _DebugMultiAction = New KeyBinding.Actions.Button.MultiAction().ButAlso( _
            Sub(o)
                o.UpActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Up 1", .Action = New KeyBinding.Actions.Button.ChangeConfigurationAction().ButAlso(Sub(o2) Connections.Add(Sub() o2.TargetConfiguration = _DebugConfigurations(2)))})
                o.UpActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Up 2", .Action = New KeyBinding.Actions.Button.ChangeConfigurationAction().ButAlso(Sub(o2) Connections.Add(Sub() o2.TargetConfiguration = _DebugConfigurations(3)))})
                o.UpActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Up 3", .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Up, .Steps = 3}})
                o.DownActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Down 1", .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Down, .Steps = 4}})
                o.DownActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Down 2", .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Down, .Steps = 8}})
                o.LeftActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Left 1", .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Left, .Steps = 5}})
                o.LeftActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Left 2", .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Left, .Steps = 9}})
                o.RightActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Right 1", .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Right, .Steps = 6}})
                o.RightActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Right 2", .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Right, .Steps = 10}})
            End Sub)

        _DebugConfigurations = _
        {
            New KeyBinding.Configurations.KeyBindingConfiguration() With {.Name = "Real Configuration"}.ButAlso( _
                Sub(o)
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.A, .Action = New KeyBinding.Actions.Button.MouseButtonAction With {.Button = KeyBinding.Actions.MouseButton.Left}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.X, .Action = New KeyBinding.Actions.Button.MouseButtonAction With {.Button = KeyBinding.Actions.MouseButton.Right}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.B, .Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.ESCAPE}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.Y, .Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.DELETE}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.DPadUp, .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Up, .Steps = 1}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.DPadDown, .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Down, .Steps = 1}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.DPadLeft, .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Left, .Steps = 1}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.DPadRight, .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Right, .Steps = 1}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.RightStickButton, .Action = New KeyBinding.Actions.Button.MouseButtonAction With {.Button = KeyBinding.Actions.MouseButton.Middle}})

                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.LeftStickButton, .Action = New KeyBinding.Actions.Button.MultiAction().ButAlso( _
                        Sub(o2)
                            o2.DownActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Bildschirmtastatur", .Action = New KeyBinding.Actions.Button.RunProgramAction With {.FilePath = "C:\Program Files\Common Files\microsoft shared\ink\TabTip.exe"}})
                        End Sub)})

                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.Back, .Action = New KeyBinding.Actions.Button.ChangeConfigurationAction().ButAlso(Sub(o2) Connections.Add(Sub() o2.TargetConfiguration = _DebugConfigurations(3)))})

                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.LeftBumper, .Action = New KeyBinding.Actions.Button.MultiAction().ButAlso( _
                        Sub(o2)
                            o2.LeftActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Backspace", .Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.BACK}})
                            o2.LeftActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Alt+Tab", .Action = New KeyBinding.Actions.Button.SequenceAction() With {.ReverseOrderOnKeyUp = True}.ButAlso( _
                                Sub(o3)
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.LWIN}})
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.TAB}})
                                End Sub)})
                            o2.RightActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Enter", .Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.RETURN}})
                            o2.RightActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Toggle NumPad", .Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.NUMLOCK}})
                            o2.UpActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "F5", .Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.F5}})
                            o2.UpActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Ctrl+Shift+B", .Action = New KeyBinding.Actions.Button.SequenceAction() With {.ReverseOrderOnKeyUp = True}.ButAlso( _
                                Sub(o3)
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.LCONTROL}})
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.LSHIFT}})
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.B}})
                                End Sub)})
                            o2.DownActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Alt+F4", .Action = New KeyBinding.Actions.Button.SequenceAction() With {.ReverseOrderOnKeyUp = True}.ButAlso( _
                                Sub(o3)
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.LMENU}})
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.F4}})
                                End Sub)})
                            o2.DownActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Ctrl+Shift+N", .Action = New KeyBinding.Actions.Button.SequenceAction() With {.ReverseOrderOnKeyUp = True}.ButAlso( _
                                Sub(o3)
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.LCONTROL}})
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.LSHIFT}})
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.N}})
                                End Sub)})
                        End Sub)})

                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.RightBumper, .Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.D1}})

                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.LeftStick, .Action = New KeyBinding.Actions.Stick.MouseMoveAction With {.SlopeMode = KeyBinding.Actions.SlopeMode.OnePointFive, .Speed = 1600, .InvertX = False, .InvertY = False}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.RightStick, .Action = New KeyBinding.Actions.Stick.MouseWheelAction With {.SlopeMode = KeyBinding.Actions.SlopeMode.Quadratic, .Speed = 10000, .InvertX = False, .InvertY = True}})
                End Sub), _
            New KeyBinding.Configurations.KeyBindingConfiguration() With {.Name = "Debug-Configuration"}.ButAlso( _
                Sub(o)
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.A, .Action = New KeyBinding.Actions.Button.ChangeConfigurationAction().ButAlso(Sub(o2) Connections.Add(Sub() o2.TargetConfiguration = _DebugConfigurations(2)))})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.B, .Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.ESCAPE, .Character = "z"c}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.X, .Action = New KeyBinding.Actions.Button.MouseButtonAction With {.Button = KeyBinding.Actions.MouseButton.Left}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.Y, .Action = New KeyBinding.Actions.Button.MouseMoveByIntervalAction With {.Direction = KeyBinding.Actions.Direction.Right, .Steps = 3}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.Start, .Action = New KeyBinding.Actions.Button.RunProgramAction With {.FilePath = "notepad.exe", .IgnoreNonExistingFilePath = True}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction() With {.Input = GamepadData.GamepadInput.LeftBumper}.ButAlso(Sub(o2) Connections.Add(Sub() o2.Action = _DebugMultiAction)))

                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.LeftStick, .Action = New KeyBinding.Actions.Stick.MouseMoveAction With {.SlopeMode = KeyBinding.Actions.SlopeMode.OnePointFive, .Speed = 1600, .InvertX = False, .InvertY = False}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.RightStick, .Action = New KeyBinding.Actions.Stick.MouseWheelAction With {.SlopeMode = KeyBinding.Actions.SlopeMode.Quadratic, .Speed = 10000, .InvertX = False, .InvertY = True}})

                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.LeftTrigger, .Action = New KeyBinding.Actions.Trigger.DebugTriggerAction})
                End Sub), _
            New KeyBinding.Configurations.KeyBindingConfiguration() With {.Name = "Dolphin"}.ButAlso( _
                Sub(o)
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.Back, .Action = New KeyBinding.Actions.Button.ChangeConfigurationAction().ButAlso(Sub(o2) Connections.Add(Sub() o2.TargetConfiguration = _DebugConfigurations(0)))})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.LeftBumper, .Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.TAB}})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.LeftStickButton, .Action = New KeyBinding.Actions.Button.MultiAction().ButAlso( _
                        Sub(o2)
                            o2.LeftActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Laden", .Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.F1}})
                            o2.RightActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Speichern", .Action = New KeyBinding.Actions.Button.SequenceAction() With {.ReverseOrderOnKeyUp = True}.ButAlso( _
                                Sub(o3)
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.SHIFT}})
                                    o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.F1}})
                                End Sub)})
                        End Sub)})
                End Sub), _
            New KeyBinding.Configurations.KeyBindingConfiguration() With {.Name = "Disabled"}.ButAlso( _
                Sub(o)
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.Back, .Action = New KeyBinding.Actions.Button.ChangeConfigurationAction().ButAlso(Sub(o2) Connections.Add(Sub() o2.TargetConfiguration = _DebugConfigurations(0)))})
                    o.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.Start, .Action = New KeyBinding.Actions.Button.SequenceAction() With {.ReverseOrderOnKeyUp = False}.ButAlso( _
                        Sub(o3)
                            o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.F5}})
                            o3.Actions.Add(New KeyBinding.Actions.Button.SequenceActionSubAction With {.Action = New KeyBinding.Actions.Button.KeyboardKeyAction With {.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey, .VirtualKey = Native.SendInput.VirtualKey.ESCAPE}})
                        End Sub)})
                End Sub), _
            New KeyBinding.Configurations.KeyBindingConfiguration With {.Name = "Test 2"}, _
            New KeyBinding.Configurations.KeyBindingConfiguration With {.Name = "Test 3"}, _
            New KeyBinding.Configurations.KeyBindingConfiguration With {.Name = "Test 4"}
        }


        

        For Each i In Connections
            i()
        Next

        IsInitialized = True
    End Sub

End Class
