﻿
Imports GamepadControl.Native.SendInput

Namespace KeyBinding.Actions.Button

    <DisplayName("Maustaste")>
    <KeyBindingActionInputKind(GamepadData.GamepadInputKind.Button)>
    <KeyBinding.Serialization.SerializableThing("MouseButtonAction")>
    Public Class MouseButtonAction
        Inherits ButtonKeyBindingActionBase

        Dim _Button As MouseButton = MouseButton.Left
        Public Property Button As MouseButton
            Get
                Return _Button
            End Get
            Set(value As MouseButton)
                ExtendedChangeIfDifferent(_Button, value, "Button")
            End Set
        End Property

        Protected Overrides Sub OnIsButtonDownChanged(IsButtonDown As Boolean, SenderGamepad As GamepadData.Gamepad)
            Dim Flags As MouseEventFlags
            Select Case Button
                Case MouseButton.Left
                    Flags = If(IsButtonDown, MouseEventFlags.LEFTDOWN, MouseEventFlags.LEFTUP)
                Case MouseButton.Right
                    Flags = If(IsButtonDown, MouseEventFlags.RIGHTDOWN, MouseEventFlags.RIGHTUP)
                Case MouseButton.Middle
                    Flags = If(IsButtonDown, MouseEventFlags.MIDDLEDOWN, MouseEventFlags.MIDDLEUP)

                Case Else
                    Throw New NopeException
            End Select
            NativeMethods.DispatchSendInput( _
                New Input With _
                {
                    .Type = Type.Mouse, _
                    .Data = New Data With _
                    {
                        .MouseInput = New MouseInput With _
                        {
                            .dwFlags = Flags
                        }
                    }
                })
        End Sub

        Public Overrides Function Clone() As KeyBindingAction
            Return New MouseButtonAction With {.Button = Me.Button}
        End Function

#Region "Serialization"

        Public Sub New()
        End Sub

        Public Sub New(Context As KeyBinding.Serialization.DeserializationContext, Source As XElement)
            Button = Source.GetAttributeEnum(Of MouseButton)("Button")
        End Sub

        Public Overrides Function Serialize(Context As KeyBinding.Serialization.SerializationContext) As XElement
            Return <MouseButtonAction
                       Button=<%= Button %>
                   />
        End Function

#End Region

    End Class

End Namespace
