﻿
Imports GamepadControl.Native.SendInput

Namespace KeyBinding.Actions.Button

    <DisplayName("Maus verschieben")>
    <KeyBindingActionInputKind(GamepadData.GamepadInputKind.Button)>
    <KeyBinding.Serialization.SerializableThing("MouseMoveByIntervalAction")>
    Public Class MouseMoveByIntervalAction
        Inherits ButtonKeyBindingActionBase

        Dim _Direction As Direction = Direction.Up
        Public Property Direction As Direction
            Get
                Return _Direction
            End Get
            Set(value As Direction)
                ExtendedChangeIfDifferent(_Direction, value, "Direction")
            End Set
        End Property

        Dim _Steps As Integer = 1
        Public Property Steps As Integer
            Get
                Return _Steps
            End Get
            Set(value As Integer)
                ExtendedChangeIfDifferent(_Steps, value, "Steps")
            End Set
        End Property

        Protected Overrides Sub OnIsButtonDownChanged(IsButtonDown As Boolean, SenderGamepad As GamepadData.Gamepad)
            If Not IsButtonDown Then
                Return
            End If
            Dim CurrentPosition = System.Windows.Forms.Cursor.Position
            Dim CurrentX = CurrentPosition.X
            Dim CurrentY = CurrentPosition.Y
            Select Case Direction
                Case Actions.Direction.Up
                    CurrentY -= Steps
                Case Actions.Direction.Down
                    CurrentY += Steps
                Case Actions.Direction.Left
                    CurrentX -= Steps
                Case Actions.Direction.Right
                    CurrentX += Steps
            End Select
            System.Windows.Forms.Cursor.Position = New System.Drawing.Point(CurrentX, CurrentY)
        End Sub

        Public Overrides Function Clone() As KeyBindingAction
            Return New MouseMoveByIntervalAction With {.Direction = Me.Direction, .Steps = Me.Steps}
        End Function

#Region "Serialization"

        Public Sub New()
        End Sub

        Public Sub New(Context As KeyBinding.Serialization.DeserializationContext, Source As XElement)
            Direction = Source.GetAttributeEnum(Of Direction)("Direction")
            Steps = Source.GetAttributeInteger("Steps")
        End Sub

        Public Overrides Function Serialize(Context As KeyBinding.Serialization.SerializationContext) As XElement
            Return <MouseMoveByIntervalAction
                       Direction=<%= Direction %>
                       Steps=<%= Steps %>
                   />
        End Function

#End Region

    End Class

End Namespace
