﻿
Namespace KeyBinding.Actions.Button

    Public Class MultiActionSubAction
        Inherits NotifyPropertyChanged

        Public Event PublicAction As EventHandler(Of KeyBindingPublicActionEventArgs)
        Protected Sub OnPublicAction(e As KeyBindingPublicActionEventArgs)
            RaiseEvent PublicAction(Me, e)
        End Sub

        Dim _Name As String = ""
        Public Property Name As String
            Get
                Return _Name
            End Get
            Set(value As String)
                ExtendedChangeIfDifferent(_Name, value, "Name")
            End Set
        End Property

        Dim _Action As KeyBinding.Actions.Button.ButtonKeyBindingActionBase = Nothing
        Public Property Action As KeyBinding.Actions.Button.ButtonKeyBindingActionBase
            Get
                Return _Action
            End Get
            Set(value As KeyBinding.Actions.Button.ButtonKeyBindingActionBase)
                Dim OldValue = _Action
                If ExtendedChangeIfDifferent(_Action, value, "Action") Then
                    If OldValue IsNot Nothing Then
                        RemoveHandler OldValue.PublicAction, AddressOf Action_PublicAction
                    End If
                    If value IsNot Nothing Then
                        AddHandler value.PublicAction, AddressOf Action_PublicAction
                    End If
                End If
            End Set
        End Property
        Private Sub Action_PublicAction(sender As Object, e As KeyBindingPublicActionEventArgs)
            OnPublicAction(e)
        End Sub

        Public Function Clone() As MultiActionSubAction
            Return New MultiActionSubAction With {.Name = Me.Name, .Action = DirectCast(Me.Action.Clone, KeyBinding.Actions.Button.ButtonKeyBindingActionBase)}
        End Function

    End Class

End Namespace
