﻿
Namespace KeyBinding.Actions.Button

    <DisplayName("Programm ausführen")>
    <KeyBindingActionInputKind(GamepadData.GamepadInputKind.Button)>
    <KeyBinding.Serialization.SerializableThing("RunProgramAction")>
    Public Class RunProgramAction
        Inherits ButtonKeyBindingActionBase

        Dim _FilePath As String = "notepad.exe"
        Public Property FilePath As String
            Get
                Return _FilePath
            End Get
            Set(value As String)
                ExtendedChangeIfDifferent(_FilePath, value, "FilePath")
            End Set
        End Property

        Dim _Arguments As String = ""
        Public Property Arguments As String
            Get
                Return _Arguments
            End Get
            Set(value As String)
                ExtendedChangeIfDifferent(_Arguments, value, "Arguments")
            End Set
        End Property

        Dim _IgnoreNonExistingFilePath As Boolean = False
        Public Property IgnoreNonExistingFilePath As Boolean
            Get
                Return _IgnoreNonExistingFilePath
            End Get
            Set(value As Boolean)
                ExtendedChangeIfDifferent(_IgnoreNonExistingFilePath, value, "IgnoreNonExistingFilePath")
            End Set
        End Property

        Protected Overrides Sub OnIsButtonDownChanged(IsButtonDown As Boolean, SenderGamepad As GamepadData.Gamepad)
            If IsButtonDown Then
                Using P As New Process
                    P.StartInfo.FileName = FilePath
                    P.StartInfo.Arguments = Arguments
                    P.Start()
                End Using
            End If
        End Sub

        Public Overrides Function Clone() As KeyBindingAction
            Return New RunProgramAction With {.FilePath = Me.FilePath, .Arguments = Me.Arguments, .IgnoreNonExistingFilePath = Me.IgnoreNonExistingFilePath}
        End Function

#Region "Serialization"

        Public Sub New()
        End Sub

        Public Sub New(Context As KeyBinding.Serialization.DeserializationContext, Source As XElement)
            FilePath = Source.GetAttributeString("FilePath")
            Arguments = Source.GetAttributeString("Arguments")
            IgnoreNonExistingFilePath = Source.GetAttributeBoolean("IgnoreNonExistingFilePath")
        End Sub

        Public Overrides Function Serialize(Context As KeyBinding.Serialization.SerializationContext) As XElement
            Return <RunProgramAction
                       FilePath=<%= FilePath %>
                       Arguments=<%= Arguments %>
                       IgnoreNonExistingFilePath=<%= IgnoreNonExistingFilePath %>
                   />
        End Function

#End Region

    End Class

End Namespace
