﻿
Namespace KeyBinding.Actions

    Public MustInherit Class KeyBindingAction
        Inherits NotifyPropertyChanged
        Implements KeyBinding.Serialization.ISerializable

        Public Event PublicAction As EventHandler(Of KeyBindingPublicActionEventArgs)
        Protected Sub OnPublicAction(e As KeyBindingPublicActionEventArgs)
            RaiseEvent PublicAction(Me, e)
        End Sub

        Public MustOverride Function Clone() As KeyBindingAction

        Public Overridable Sub ReplaceReferencedConfiguration(ToReplace As KeyBinding.Configurations.KeyBindingConfiguration, ReplaceWith As KeyBinding.Configurations.KeyBindingConfiguration)
        End Sub

        Public MustOverride Function Serialize(Context As KeyBinding.Serialization.SerializationContext) As XElement Implements KeyBinding.Serialization.ISerializable.Serialize

        Public Shared Function SubTypesOfInputKind(Kind As GamepadData.GamepadInputKind) As IEnumerable(Of Type)
            Return From TypeWithAttributes In GetType(KeyBinding.Actions.KeyBindingAction).SubTypesWithAttribute(Of KeyBinding.Actions.KeyBindingActionInputKindAttribute)()
                   Where TypeWithAttributes.Attributes.Single.Kind = Kind
                   Select TypeWithAttributes.Type
        End Function

    End Class

End Namespace
