﻿
Imports GamepadControl.Native.SendInput

Namespace KeyBinding.Actions.Stick

    <DisplayName("Maus bewegen")>
    <KeyBindingActionInputKind(GamepadData.GamepadInputKind.Stick)>
    <KeyBinding.Serialization.SerializableThing("MouseMoveAction")>
    Public Class MouseMoveAction
        Inherits StickKeyBindingActionBase

        <MultithreadingAwareness()>
        Protected Overrides Sub ApplyActionCore(MovementX As Integer, MovementY As Integer)
            NativeMethods.DispatchSendInput( _
                New Input With _
                {
                    .Type = Type.Mouse, _
                    .Data = New Data With _
                    {
                        .MouseInput = New MouseInput With _
                        {
                            .dx = MovementX, _
                            .dy = MovementY, _
                            .dwFlags = MouseEventFlags.MOVE
                        }
                    }
                })
        End Sub

        Protected Overrides Function CloneStickKeyBindingActionBase() As StickKeyBindingActionBase
            Return New MouseMoveAction
        End Function

#Region "Serialization"

        Public Sub New()
        End Sub

        Public Sub New(Context As KeyBinding.Serialization.DeserializationContext, Source As XElement)
            MyBase.New(Context, Source.<Base>.Elements.Single)
        End Sub

        Public Overrides Function Serialize(Context As KeyBinding.Serialization.SerializationContext) As XElement
            Return <MouseMoveAction>
                       <Base>
                           <%= MyBase.Serialize(Context) %>
                       </Base>
                   </MouseMoveAction>
        End Function

#End Region

    End Class

End Namespace
