﻿
Imports GamepadControl.Native.SendInput

Namespace KeyBinding.Actions.Stick

    <DisplayName("Mausrad drehen")>
    <KeyBindingActionInputKind(GamepadData.GamepadInputKind.Stick)>
    <KeyBinding.Serialization.SerializableThing("MouseWheelAction")>
    Public Class MouseWheelAction
        Inherits StickKeyBindingActionBase

        Public Sub New()
            MovementFactor = New Vector2D(6, 1)
        End Sub

        <MultithreadingAwareness()>
        Protected Overrides Sub ApplyActionCore(MovementX As Integer, MovementY As Integer)
            If MovementX <> 0 Then
                SendInput(MovementX, MouseEventFlags.HWHEEL)
            End If
            If MovementY <> 0 Then
                SendInput(MovementY, MouseEventFlags.WHEEL)
            End If
        End Sub

        Private Sub SendInput(Data As Int32, Flags As MouseEventFlags)
            NativeMethods.DispatchSendInput( _
                New Input With _
                {
                    .Type = Type.Mouse, _
                    .Data = New Data With _
                    {
                        .MouseInput = New MouseInput With _
                        {
                            .mouseData = Data, _
                            .dwFlags = Flags
                        }
                    }
                })
        End Sub

        Protected Overrides Function CloneStickKeyBindingActionBase() As StickKeyBindingActionBase
            Return New MouseWheelAction
        End Function

#Region "Serialization"

        Public Sub New(Context As KeyBinding.Serialization.DeserializationContext, Source As XElement)
            MyBase.New(Context, Source.<Base>.Elements.Single)
        End Sub

        Public Overrides Function Serialize(Context As KeyBinding.Serialization.SerializationContext) As XElement
            Return <MouseWheelAction>
                       <Base>
                           <%= MyBase.Serialize(Context) %>
                       </Base>
                   </MouseWheelAction>
        End Function

#End Region

    End Class

End Namespace
