﻿
Namespace KeyBinding.Configurations

    Public Class BoundAction
        Inherits NotifyPropertyChanged

        Public Event PublicAction As EventHandler(Of KeyBinding.Actions.KeyBindingPublicActionEventArgs)
        Protected Sub OnPublicAction(e As KeyBinding.Actions.KeyBindingPublicActionEventArgs)
            RaiseEvent PublicAction(Me, e)
        End Sub

        Dim _Input As GamepadData.GamepadInput = GamepadData.GamepadInput.A
        Public Property Input As GamepadData.GamepadInput
            Get
                Return _Input
            End Get
            Set(value As GamepadData.GamepadInput)
                ExtendedChangeIfDifferent(_Input, value, "Input")
            End Set
        End Property

        Dim _Action As KeyBinding.Actions.KeyBindingAction = Nothing
        Public Property Action As KeyBinding.Actions.KeyBindingAction
            Get
                Return _Action
            End Get
            Set(value As KeyBinding.Actions.KeyBindingAction)
                Dim OldValue = value
                If ExtendedChangeIfDifferent(_Action, value, "Action") Then
                    If OldValue IsNot Nothing Then
                        RemoveHandler OldValue.PublicAction, AddressOf Action_PublicAction
                    End If
                    If value IsNot Nothing Then
                        AddHandler value.PublicAction, AddressOf Action_PublicAction
                    End If
                End If
            End Set
        End Property
        Private Sub Action_PublicAction(sender As Object, e As KeyBinding.Actions.KeyBindingPublicActionEventArgs)
            OnPublicAction(e)
        End Sub

        Public Function Clone() As BoundAction
            Return New BoundAction With {.Input = Me.Input, .Action = Me.Action.Clone}
        End Function

    End Class

End Namespace
