﻿
Namespace KeyBinding.Configurations

    Public Class KeyBindingConfiguration
        Inherits NotifyPropertyChanged

        Public Event PublicAction As EventHandler(Of KeyBinding.Actions.KeyBindingPublicActionEventArgs)
        Protected Sub OnPublicAction(e As KeyBinding.Actions.KeyBindingPublicActionEventArgs)
            RaiseEvent PublicAction(Me, e)
        End Sub

        Dim _Name As String = "Neue Konfiguration"
        Public Property Name As String
            Get
                Return _Name
            End Get
            Set(value As String)
                ExtendedChangeIfDifferent(_Name, value, "Name")
            End Set
        End Property

        Dim WithEvents _Actions As New TypedObservableCollection(Of BoundAction)
        Public ReadOnly Property Actions As TypedObservableCollection(Of BoundAction)
            Get
                Return _Actions
            End Get
        End Property
        Private Sub Actions_ItemAdded(sender As Object, e As ItemEventArgs(Of BoundAction)) Handles _Actions.ItemAdded
            AddHandler e.Item.PublicAction, AddressOf Action_PublicAction
        End Sub
        Private Sub Actions_ItemRemoved(sender As Object, e As ItemEventArgs(Of BoundAction)) Handles _Actions.ItemRemoved
            RemoveHandler e.Item.PublicAction, AddressOf Action_PublicAction
        End Sub
        Private Sub Action_PublicAction(sender As Object, e As KeyBinding.Actions.KeyBindingPublicActionEventArgs)
            OnPublicAction(e)
        End Sub

        Public Function Clone() As KeyBindingConfiguration
            Dim Result As New KeyBindingConfiguration With {.Name = Me.Name}
            Result.Actions.AddRange(Me.Actions.Select(Function(i) i.Clone))
            Return Result
        End Function

    End Class

End Namespace
