﻿
Imports System.Runtime.InteropServices

Namespace Native.SendInput

    Public Class NativeMethods

        Private Declare Function U_SendInput Lib "user32.dll" Alias "SendInput" (<[In]()> nInputs As UInt32, _
                                                                                 <[In]()> <MarshalAs(UnmanagedType.Struct, ArraySubType:=UnmanagedType.Struct, SizeParamIndex:=0)> ByRef pInputs As Input, _
                                                                                 <[In]()> cbSize As Int32) As UInt32

        Public Shared Sub SendInput(Data As Input)
            'Debug.Print("{0} Send in {1}", DateTime.Now.Second & "." & DateTime.Now.Millisecond, System.Threading.Thread.CurrentThread.ManagedThreadId)
            U_SendInput(1, Data, Marshal.SizeOf(Data))
            Dim LastError = Marshal.GetLastWin32Error
            If LastError <> 0 Then
                Debug.Print("LastError: {0:X8}", LastError)
            End If
        End Sub

        Public Shared Sub DispatchSendInput(Data As Input)
            'Debug.Print("{0} Dispatch in {1}", DateTime.Now.Second & "." & DateTime.Now.Millisecond, System.Threading.Thread.CurrentThread.ManagedThreadId)
            SendInput(Data)
            'System.Threading.Tasks.Task.Factory.StartNew(Sub() SendInput(Data))
        End Sub

    End Class

End Namespace
