﻿
Imports System.Collections.Specialized

Public Class ObservableReverseCollection(Of TItem, TList As {Class, IEnumerable(Of TItem), INotifyCollectionChanged})
    Implements IWeakEventListener
    Implements IEnumerable(Of TItem)
    Implements INotifyCollectionChanged

    Public Event CollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs) Implements INotifyCollectionChanged.CollectionChanged

    Dim Source As TList

    Public Sub New(NewSource As TList)
        Source = NewSource
        CollectionChangedEventManager.AddListener(Source, Me)
    End Sub

    Public Function GetEnumerator() As IEnumerator(Of TItem) Implements IEnumerable(Of TItem).GetEnumerator
        Return Source.Reverse.GetEnumerator
    End Function

    Private Function IEnumerable_GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
        Return GetEnumerator()
    End Function

    Public Function ReceiveWeakEvent(managerType As Type, sender As Object, e As EventArgs) As Boolean Implements IWeakEventListener.ReceiveWeakEvent
        Select Case managerType
            Case GetType(CollectionChangedEventManager)
                WeakEvent_CollectionChanged(sender, DirectCast(e, NotifyCollectionChangedEventArgs))
            Case Else
                Return False
        End Select
        Return True
    End Function

    Private Sub WeakEvent_CollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs)
        Select Case True
            Case sender Is Source
                Source_CollectionChanged(e)
        End Select
    End Sub

    Private Sub Source_CollectionChanged(e As NotifyCollectionChangedEventArgs)
        RaiseEvent CollectionChanged(Me, New NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset))
    End Sub

End Class
