﻿
Imports System.Collections.Specialized

Public Class ObservableSelectorCollection(Of TInput, TList As {Class, IEnumerable(Of TInput), INotifyCollectionChanged}, TOutput)
    Implements IEnumerable(Of TOutput)
    Implements INotifyCollectionChanged

    Public Event CollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs) Implements INotifyCollectionChanged.CollectionChanged

    Dim Source As TList
    Dim Selector As Func(Of TInput, TOutput)

    Public Sub New(NewSource As TList, NewSelector As Func(Of TInput, TOutput))
        Source = NewSource
        Selector = NewSelector
        AddHandler Source.CollectionChanged, AddressOf Source_CollectionChanged
    End Sub

    Public Function GetEnumerator() As IEnumerator(Of TOutput) Implements IEnumerable(Of TOutput).GetEnumerator
        Return Source.Select(Selector).GetEnumerator
    End Function

    Private Function IEnumerable_GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
        Return GetEnumerator()
    End Function

    Private Sub Source_CollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs)
        RaiseEvent CollectionChanged(Me, New NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset))
    End Sub

End Class
