﻿Public Structure Vector2D

    Private _X As Double
    Public ReadOnly Property X As Double
        <DebuggerStepThrough()>
        Get
            Return _X
        End Get
    End Property

    Private _Y As Double
    Public ReadOnly Property Y As Double
        <DebuggerStepThrough()>
        Get
            Return _Y
        End Get
    End Property

    Public ReadOnly Property Length As Double
        Get
            Return Math.Sqrt(X ^ 2 + Y ^ 2)
        End Get
    End Property

    Public ReadOnly Property Angle As Double
        Get
            Dim MinusPlusAngle = Math.Atan2(Y, X)
            If MinusPlusAngle < 0 Then
                Return MinusPlusAngle + Math.PI * 2
            End If
            Return MinusPlusAngle
        End Get
    End Property

    Public Sub New(NewX As Double, NewY As Double)
        _X = NewX
        _Y = NewY
    End Sub

    Public Shared Function ComponentwiseProduct(Left As Vector2D, Right As Vector2D) As Vector2D
        Return New Vector2D(Left.X * Right.X, Left.Y * Right.Y)
    End Function

    Public Shared Function FromPolar(Length As Double, Angle As Double) As Vector2D
        Return New Vector2D(Math.Cos(Angle) * Length, Math.Sin(Angle) * Length)
    End Function

End Structure
