﻿
Namespace Views.KeyBindingConfigurationDialog

    Public Class KeyBindingConfigurationDialog

        Dim _EditedConfiguration As KeyBinding.Configurations.KeyBindingConfiguration
        Public ReadOnly Property EditedConfiguration As KeyBinding.Configurations.KeyBindingConfiguration
            Get
                Return _EditedConfiguration
            End Get
        End Property

        Dim ViewModel As KeyBindingConfigurationDialogViewModel

        Public Sub New()
            Me.New(DebugData.DebugConfigurations.Skip(1), DebugData.DebugConfigurations(0))
        End Sub

        Public Sub New(NewExistingConfigurations As IEnumerable(Of KeyBinding.Configurations.KeyBindingConfiguration), NewEditedConfiguration As KeyBinding.Configurations.KeyBindingConfiguration)
            InitializeComponent()
            _EditedConfiguration = NewEditedConfiguration
            ViewModel = DirectCast(Me.DataContext, KeyBindingConfigurationDialogViewModel)
            ViewModel.SetEditedData(NewExistingConfigurations, NewEditedConfiguration)
        End Sub

        Private Sub CloseOk(sender As System.Object, e As System.Windows.RoutedEventArgs)
            Me.DialogResult = True
            Me.Close()
        End Sub

        Private Sub CloseCancel(sender As System.Object, e As System.Windows.RoutedEventArgs)
            Me.DialogResult = False
            Me.Close()
        End Sub

        Private Sub AddNewAction(sender As System.Object, e As System.Windows.RoutedEventArgs)
            ViewModel.EditedConfiguration.Target.Actions.Add(New KeyBinding.Configurations.BoundAction With {.Input = GamepadData.GamepadInput.A, .Action = Nothing})
        End Sub

    End Class

End Namespace
