﻿
Namespace Views.KeyBindingConfigurationDialog.ViewModels.Button

    <ViewModelForAttribute(GetType(KeyBinding.Actions.Button.KeyboardKeyAction))>
    Public Class KeyboardKeyAction
        Inherits KeyBindingConfigurationDialogSubViewModel

        <Dependency("CharacterTextIsValid")>
        Public Overrides ReadOnly Property IsValid As Boolean
            Get
                Return CharacterTextIsValid
            End Get
        End Property

        Dim _CharacterText As String = "a"
        Public Property CharacterText As String
            Get
                Return _CharacterText
            End Get
            Set(value As String)
                If ExtendedChangeIfDifferent(_CharacterText, value, "CharacterText") Then
                    If _CharacterText.Length = 1 Then
                        CastedTarget.Character = _CharacterText(0)
                    End If
                End If
            End Set
        End Property

        <Dependency("CharacterText")>
        Public ReadOnly Property CharacterTextIsValid As Boolean
            Get
                If CastedTarget.Mode = KeyBinding.Actions.KeyboardMode.Character Then
                    Return CharacterText.Length = 1
                End If
                Return True
            End Get
        End Property

        Public ReadOnly Property VirtualKeyInputIsVisible As Boolean
            Get
                Return CastedTarget.Mode = KeyBinding.Actions.KeyboardMode.VirtualKey
            End Get
        End Property

        Public ReadOnly Property CharacterInputIsVisible As Boolean
            Get
                Return CastedTarget.Mode = KeyBinding.Actions.KeyboardMode.Character
            End Get
        End Property

        Dim _CastedTarget As KeyBinding.Actions.Button.KeyboardKeyAction
        Public ReadOnly Property CastedTarget As KeyBinding.Actions.Button.KeyboardKeyAction
            Get
                Return _CastedTarget
            End Get
        End Property

        Public Sub New(NewTarget As KeyBinding.Actions.Button.KeyboardKeyAction)
            MyBase.New(NewTarget)
            _CastedTarget = NewTarget
            AddExternalPropertyDependency("VirtualKeyInputIsVisible", CastedTarget, "Mode")
            AddExternalPropertyDependency("CharacterInputIsVisible", CastedTarget, "Mode")
            _CharacterText = _CastedTarget.Character
        End Sub

    End Class

End Namespace
