﻿
Namespace Views.KeyBindingConfigurationDialog.ViewModels.Button

    <ViewModelForAttribute(GetType(KeyBinding.Actions.Button.MouseMoveByIntervalAction))>
    Public Class MouseMoveByIntervalAction
        Inherits KeyBindingConfigurationDialogSubViewModel

        <Dependency("StepsTextIsValid")>
        Public Overrides ReadOnly Property IsValid As Boolean
            Get
                Return StepsTextIsValid
            End Get
        End Property

        Dim _StepsText As String = "1"
        Public Property StepsText As String
            Get
                Return _StepsText
            End Get
            Set(value As String)
                If ExtendedChangeIfDifferent(_StepsText, value, "StepsText") Then
                    StepsTextIsValid = Integer.TryParse(_StepsText, CastedTarget.Steps) AndAlso CastedTarget.Steps >= 1
                End If
            End Set
        End Property

        Dim _StepsTextIsValid As Boolean = True
        Public Property StepsTextIsValid As Boolean
            Get
                Return _StepsTextIsValid
            End Get
            Private Set(value As Boolean)
                ExtendedChangeIfDifferent(_StepsTextIsValid, value, "StepsTextIsValid")
            End Set
        End Property

        Dim _CastedTarget As KeyBinding.Actions.Button.MouseMoveByIntervalAction
        Public ReadOnly Property CastedTarget As KeyBinding.Actions.Button.MouseMoveByIntervalAction
            Get
                Return _CastedTarget
            End Get
        End Property

        Public Sub New(NewTarget As KeyBinding.Actions.Button.MouseMoveByIntervalAction)
            MyBase.New(NewTarget)
            _CastedTarget = NewTarget
            _StepsText = _CastedTarget.Steps.ToString
        End Sub

    End Class

End Namespace
