﻿
Namespace Views.KeyBindingConfigurationDialog.ViewModels.Button

    <ViewModelForAttribute(GetType(KeyBinding.Actions.Button.MultiAction))>
    Public Class MultiAction
        Inherits KeyBindingConfigurationDialogSubViewModel

        Public ReadOnly Property AddNewUpActionCommand As DelegateCommand
            Get
                Static Temp As New DelegateCommand(Sub() CastedTarget.UpActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Neue Aktion", .Action = Nothing}))
                Return Temp
            End Get
        End Property

        Public ReadOnly Property AddNewDownActionCommand As DelegateCommand
            Get
                Static Temp As New DelegateCommand(Sub() CastedTarget.DownActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Neue Aktion", .Action = Nothing}))
                Return Temp
            End Get
        End Property

        Public ReadOnly Property AddNewLeftActionCommand As DelegateCommand
            Get
                Static Temp As New DelegateCommand(Sub() CastedTarget.LeftActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Neue Aktion", .Action = Nothing}))
                Return Temp
            End Get
        End Property

        Public ReadOnly Property AddNewRightActionCommand As DelegateCommand
            Get
                Static Temp As New DelegateCommand(Sub() CastedTarget.RightActions.Add(New KeyBinding.Actions.Button.MultiActionSubAction With {.Name = "Neue Aktion", .Action = Nothing}))
                Return Temp
            End Get
        End Property

        Public Overrides ReadOnly Property IsValid As Boolean
            Get
                If Not UpActions.ViewModels.All(Function(i) i.IsValid) Then
                    Return False
                End If
                If Not DownActions.ViewModels.All(Function(i) i.IsValid) Then
                    Return False
                End If
                If Not LeftActions.ViewModels.All(Function(i) i.IsValid) Then
                    Return False
                End If
                If Not RightActions.ViewModels.All(Function(i) i.IsValid) Then
                    Return False
                End If
                Return CastedTarget.UpActions.Count <> 0 OrElse _
                       CastedTarget.DownActions.Count <> 0 OrElse _
                       CastedTarget.LeftActions.Count <> 0 OrElse _
                       CastedTarget.RightActions.Count <> 0
            End Get
        End Property

        Dim WithEvents _UpActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
        Public Property UpActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
            Get
                Return _UpActions
            End Get
            Set(value As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel))
                Dim OldValue = _UpActions
                If ChangeIfDifferent(_UpActions, value) Then
                    OnExtendedPropertyChanged("UpActions", OldValue, value) 'WithEvents Property
                End If
            End Set
        End Property
        Private Sub UpActions_ItemCreating(sender As Object, e As ViewModelCollectionItemCreatingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _UpActions.ItemCreating
            e.ViewModel = New MultiActionSubActionViewModel(e.Item)
            AddHandler e.ViewModel.Remove, AddressOf UpAction_Remove
            AddHandler e.ViewModel.PropertyChanged, AddressOf Action_PropertyChanged
            AddHandler e.ViewModel.MoveUp, AddressOf UpAction_MoveUp
            AddHandler e.ViewModel.MoveDown, AddressOf UpAction_MoveDown
        End Sub
        Private Sub UpActions_ItemDisposing(sender As Object, e As ViewModelCollectionItemDisposingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _UpActions.ItemDisposing
            RemoveHandler e.ViewModel.Remove, AddressOf UpAction_Remove
            RemoveHandler e.ViewModel.PropertyChanged, AddressOf Action_PropertyChanged
            RemoveHandler e.ViewModel.MoveUp, AddressOf UpAction_MoveUp
            RemoveHandler e.ViewModel.MoveDown, AddressOf UpAction_MoveDown
        End Sub
        Private Sub UpAction_Remove(Sender As MultiActionSubActionViewModel)
            CastedTarget.UpActions.Remove(Sender.Target)
        End Sub
        Private Sub UpAction_MoveUp(Sender As MultiActionSubActionViewModel)
            Dim Index = CastedTarget.UpActions.IndexOf(Sender.Target)
            If Index > 0 Then
                CastedTarget.UpActions.Move(Index, Index - 1)
            End If
        End Sub
        Private Sub UpAction_MoveDown(Sender As MultiActionSubActionViewModel)
            Dim Index = CastedTarget.UpActions.IndexOf(Sender.Target)
            If Index < CastedTarget.UpActions.Count - 1 Then
                CastedTarget.UpActions.Move(Index, Index + 1)
            End If
        End Sub

        Dim WithEvents _DownActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
        Public Property DownActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
            Get
                Return _DownActions
            End Get
            Set(value As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel))
                Dim OldValue = _DownActions
                If ChangeIfDifferent(_DownActions, value) Then
                    OnExtendedPropertyChanged("DownActions", OldValue, value) 'WithEvents Property
                End If
            End Set
        End Property
        Private Sub DownActions_ItemCreating(sender As Object, e As ViewModelCollectionItemCreatingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _DownActions.ItemCreating
            e.ViewModel = New MultiActionSubActionViewModel(e.Item)
            AddHandler e.ViewModel.Remove, AddressOf DownAction_Remove
            AddHandler e.ViewModel.PropertyChanged, AddressOf Action_PropertyChanged
            AddHandler e.ViewModel.MoveUp, AddressOf DownAction_MoveUp
            AddHandler e.ViewModel.MoveDown, AddressOf DownAction_MoveDown
        End Sub
        Private Sub DownActions_ItemDisposing(sender As Object, e As ViewModelCollectionItemDisposingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _DownActions.ItemDisposing
            RemoveHandler e.ViewModel.Remove, AddressOf DownAction_Remove
            RemoveHandler e.ViewModel.PropertyChanged, AddressOf Action_PropertyChanged
            RemoveHandler e.ViewModel.MoveUp, AddressOf DownAction_MoveUp
            RemoveHandler e.ViewModel.MoveDown, AddressOf DownAction_MoveDown
        End Sub
        Private Sub DownAction_Remove(Sender As MultiActionSubActionViewModel)
            CastedTarget.DownActions.Remove(Sender.Target)
        End Sub
        Private Sub DownAction_MoveUp(Sender As MultiActionSubActionViewModel)
            Dim Index = CastedTarget.DownActions.IndexOf(Sender.Target)
            If Index > 0 Then
                CastedTarget.DownActions.Move(Index, Index - 1)
            End If
        End Sub
        Private Sub DownAction_MoveDown(Sender As MultiActionSubActionViewModel)
            Dim Index = CastedTarget.DownActions.IndexOf(Sender.Target)
            If Index < CastedTarget.DownActions.Count - 1 Then
                CastedTarget.DownActions.Move(Index, Index + 1)
            End If
        End Sub

        Dim WithEvents _LeftActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
        Public Property LeftActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
            Get
                Return _LeftActions
            End Get
            Set(value As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel))
                Dim OldValue = _LeftActions
                If ChangeIfDifferent(_LeftActions, value) Then
                    OnExtendedPropertyChanged("LeftActions", OldValue, value) 'WithEvents Property
                End If
            End Set
        End Property
        Private Sub LeftActions_ItemCreating(sender As Object, e As ViewModelCollectionItemCreatingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _LeftActions.ItemCreating
            e.ViewModel = New MultiActionSubActionViewModel(e.Item)
            AddHandler e.ViewModel.Remove, AddressOf LeftAction_Remove
            AddHandler e.ViewModel.PropertyChanged, AddressOf Action_PropertyChanged
            AddHandler e.ViewModel.MoveUp, AddressOf LeftAction_MoveUp
            AddHandler e.ViewModel.MoveDown, AddressOf LeftAction_MoveDown
        End Sub
        Private Sub LeftActions_ItemDisposing(sender As Object, e As ViewModelCollectionItemDisposingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _LeftActions.ItemDisposing
            RemoveHandler e.ViewModel.Remove, AddressOf LeftAction_Remove
            RemoveHandler e.ViewModel.PropertyChanged, AddressOf Action_PropertyChanged
            RemoveHandler e.ViewModel.MoveUp, AddressOf LeftAction_MoveUp
            RemoveHandler e.ViewModel.MoveDown, AddressOf LeftAction_MoveDown
        End Sub
        Private Sub LeftAction_Remove(Sender As MultiActionSubActionViewModel)
            CastedTarget.LeftActions.Remove(Sender.Target)
        End Sub
        Private Sub LeftAction_MoveUp(Sender As MultiActionSubActionViewModel)
            Dim Index = CastedTarget.LeftActions.IndexOf(Sender.Target)
            If Index > 0 Then
                CastedTarget.LeftActions.Move(Index, Index - 1)
            End If
        End Sub
        Private Sub LeftAction_MoveDown(Sender As MultiActionSubActionViewModel)
            Dim Index = CastedTarget.LeftActions.IndexOf(Sender.Target)
            If Index < CastedTarget.LeftActions.Count - 1 Then
                CastedTarget.LeftActions.Move(Index, Index + 1)
            End If
        End Sub

        Dim WithEvents _RightActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
        Public Property RightActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
            Get
                Return _RightActions
            End Get
            Set(value As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel))
                Dim OldValue = _RightActions
                If ChangeIfDifferent(_RightActions, value) Then
                    OnExtendedPropertyChanged("RightActions", OldValue, value) 'WithEvents Property
                End If
            End Set
        End Property
        Private Sub RightActions_ItemCreating(sender As Object, e As ViewModelCollectionItemCreatingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _RightActions.ItemCreating
            e.ViewModel = New MultiActionSubActionViewModel(e.Item)
            AddHandler e.ViewModel.Remove, AddressOf RightAction_Remove
            AddHandler e.ViewModel.PropertyChanged, AddressOf Action_PropertyChanged
            AddHandler e.ViewModel.MoveUp, AddressOf RightAction_MoveUp
            AddHandler e.ViewModel.MoveDown, AddressOf RightAction_MoveDown
        End Sub
        Private Sub RightActions_ItemDisposing(sender As Object, e As ViewModelCollectionItemDisposingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _RightActions.ItemDisposing
            RemoveHandler e.ViewModel.Remove, AddressOf RightAction_Remove
            RemoveHandler e.ViewModel.PropertyChanged, AddressOf Action_PropertyChanged
            RemoveHandler e.ViewModel.MoveUp, AddressOf RightAction_MoveUp
            RemoveHandler e.ViewModel.MoveDown, AddressOf RightAction_MoveDown
        End Sub
        Private Sub RightAction_Remove(Sender As MultiActionSubActionViewModel)
            CastedTarget.RightActions.Remove(Sender.Target)
        End Sub
        Private Sub RightAction_MoveUp(Sender As MultiActionSubActionViewModel)
            Dim Index = CastedTarget.RightActions.IndexOf(Sender.Target)
            If Index > 0 Then
                CastedTarget.RightActions.Move(Index, Index - 1)
            End If
        End Sub
        Private Sub RightAction_MoveDown(Sender As MultiActionSubActionViewModel)
            Dim Index = CastedTarget.RightActions.IndexOf(Sender.Target)
            If Index < CastedTarget.RightActions.Count - 1 Then
                CastedTarget.RightActions.Move(Index, Index + 1)
            End If
        End Sub

        Dim _CastedTarget As KeyBinding.Actions.Button.MultiAction
        Public ReadOnly Property CastedTarget As KeyBinding.Actions.Button.MultiAction
            Get
                Return _CastedTarget
            End Get
        End Property

        Public Sub New(NewTarget As KeyBinding.Actions.Button.MultiAction)
            MyBase.New(NewTarget)
            _CastedTarget = NewTarget
            AddExternalPropertyDependency("IsValid", _CastedTarget.UpActions, "Count")
            AddExternalPropertyDependency("IsValid", _CastedTarget.DownActions, "Count")
            AddExternalPropertyDependency("IsValid", _CastedTarget.LeftActions, "Count")
            AddExternalPropertyDependency("IsValid", _CastedTarget.RightActions, "Count")
            UpActions = New ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)(New ObservableCollectionSource(Of KeyBinding.Actions.Button.MultiActionSubAction)(_CastedTarget.UpActions))
            UpActions.SynchronizeWithList(CastedTarget.UpActions)
            DownActions = New ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)(New ObservableCollectionSource(Of KeyBinding.Actions.Button.MultiActionSubAction)(_CastedTarget.DownActions))
            DownActions.SynchronizeWithList(CastedTarget.DownActions)
            LeftActions = New ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)(New ObservableCollectionSource(Of KeyBinding.Actions.Button.MultiActionSubAction)(_CastedTarget.LeftActions))
            LeftActions.SynchronizeWithList(CastedTarget.LeftActions)
            RightActions = New ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)(New ObservableCollectionSource(Of KeyBinding.Actions.Button.MultiActionSubAction)(_CastedTarget.RightActions))
            RightActions.SynchronizeWithList(CastedTarget.RightActions)
        End Sub

        Private Sub Action_PropertyChanged(sender As Object, e As PropertyChangedEventArgs)
            Select Case e.PropertyName
                Case "IsValid"
                    OnPropertyChanged("IsValid")
            End Select
        End Sub

    End Class

End Namespace
