﻿
Namespace Views.KeyBindingConfigurationDialog.ViewModels.Button

    <ViewModelForAttribute(GetType(KeyBinding.Actions.Button.RunProgramAction))>
    Public Class RunProgramAction
        Inherits KeyBindingConfigurationDialogSubViewModel

        <Dependency("FilePathIsValid")>
        Public Overrides ReadOnly Property IsValid As Boolean
            Get
                Return FilePathIsValid
            End Get
        End Property

        Public ReadOnly Property FilePathIsValid As Boolean
            Get
                Return CastedTarget.IgnoreNonExistingFilePath OrElse System.IO.File.Exists(CastedTarget.FilePath)
            End Get
        End Property

        Dim _CastedTarget As KeyBinding.Actions.Button.RunProgramAction
        Public ReadOnly Property CastedTarget As KeyBinding.Actions.Button.RunProgramAction
            Get
                Return _CastedTarget
            End Get
        End Property

        Public Sub New(NewTarget As KeyBinding.Actions.Button.RunProgramAction)
            MyBase.New(NewTarget)
            _CastedTarget = NewTarget
            AddExternalPropertyDependency("FilePathIsValid", _CastedTarget, "FilePath")
            AddExternalPropertyDependency("FilePathIsValid", _CastedTarget, "IgnoreNonExistingFilePath")
        End Sub

    End Class

End Namespace
