﻿
Namespace Views.KeyBindingConfigurationDialog.ViewModels

    Public MustInherit Class KeyBindingConfigurationDialogSubViewModel
        Inherits ViewModelBase(Of KeyBinding.Actions.KeyBindingAction)

        MustOverride ReadOnly Property IsValid As Boolean

        Public Sub New(NewTarget As KeyBinding.Actions.KeyBindingAction)
            MyBase.New(NewTarget)
        End Sub

        Public Shared Function GetViewModelFor(Action As KeyBinding.Actions.KeyBindingAction) As KeyBindingConfigurationDialogSubViewModel
            Dim CandidateTypes = GetType(KeyBindingConfigurationDialogSubViewModel).SubTypesWithAttribute(Of ViewModelForAttribute)()
            Dim MatchingType = CandidateTypes.Single(Function(i) i.Attributes.Single.TargetType = Action.GetType).Type
            Dim Constructor = MatchingType.GetConstructor(Reflection.BindingFlags.Public Or Reflection.BindingFlags.Instance, Nothing, {Action.GetType}, Nothing)
            Return DirectCast(Constructor.Invoke({Action}), ViewModels.KeyBindingConfigurationDialogSubViewModel)
        End Function

    End Class

End Namespace
