﻿
Namespace Views.KeyBindingConfigurationDialog.ViewModels.Stick

    <ViewModelForAttribute(GetType(KeyBinding.Actions.Stick.MouseWheelAction))>
    Public Class MouseWheelAction
        Inherits KeyBindingConfigurationDialogSubViewModel

        Public Overrides ReadOnly Property IsValid As Boolean
            Get
                Return SpeedTextIsValid
            End Get
        End Property

        Dim _SpeedText As String = "100"
        Public Property SpeedText As String
            Get
                Return _SpeedText
            End Get
            Set(value As String)
                If ExtendedChangeIfDifferent(_SpeedText, value, "SpeedText") Then
                    SpeedTextIsValid = Double.TryParse(_SpeedText, CastedTarget.Speed) AndAlso CastedTarget.Speed <> 0
                End If
            End Set
        End Property

        Dim _SpeedTextIsValid As Boolean = True
        Public Property SpeedTextIsValid As Boolean
            Get
                Return _SpeedTextIsValid
            End Get
            Private Set(value As Boolean)
                ExtendedChangeIfDifferent(_SpeedTextIsValid, value, "SpeedTextIsValid")
            End Set
        End Property

        Dim _CastedTarget As KeyBinding.Actions.Stick.MouseWheelAction
        Public ReadOnly Property CastedTarget As KeyBinding.Actions.Stick.MouseWheelAction
            Get
                Return _CastedTarget
            End Get
        End Property

        Public Sub New(NewTarget As KeyBinding.Actions.Stick.MouseWheelAction)
            MyBase.New(NewTarget)
            _CastedTarget = NewTarget
            _SpeedText = _CastedTarget.Speed.ToString
        End Sub

    End Class

End Namespace
