﻿
Namespace Views.MainWindow

    Public Class KeyBindingConfigurationViewModelListTargetSelectorConverter
        Implements IValueConverter

        Public Function Convert(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.Convert
            If TypeOf value Is ObservableCollection(Of KeyBindingConfigurationViewModel) Then
                Return New ObservableSelectorCollection _
                       (Of KeyBindingConfigurationViewModel,  _
                           ObservableCollection(Of KeyBindingConfigurationViewModel),  _
                           KeyBinding.Configurations.KeyBindingConfiguration) _
                       (DirectCast(value, ObservableCollection(Of KeyBindingConfigurationViewModel)), _
                        Function(i) i.Target)
            ElseIf TypeOf value Is ReadOnlyObservableCollection(Of KeyBindingConfigurationViewModel) Then
                Return New ObservableSelectorCollection _
                       (Of KeyBindingConfigurationViewModel,  _
                           ReadOnlyObservableCollection(Of KeyBindingConfigurationViewModel),  _
                           KeyBinding.Configurations.KeyBindingConfiguration) _
                       (DirectCast(value, ReadOnlyObservableCollection(Of KeyBindingConfigurationViewModel)), _
                        Function(i) i.Target)
            Else
                Return Binding.DoNothing
            End If
        End Function

        Public Function ConvertBack(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.ConvertBack
            Return Binding.DoNothing
        End Function

    End Class

End Namespace
