
Imports Direction = GamepadControl.KeyBinding.Actions.Direction

Namespace Views.MultiActionSelectorWindow

    Public Class MultiActionSelectorWindowViewModel
        Inherits ViewModelBase

        Dim _Action As KeyBinding.Actions.Button.MultiAction = Nothing
        Public Property Action As KeyBinding.Actions.Button.MultiAction
            Get
                Return _Action
            End Get
            Private Set(value As KeyBinding.Actions.Button.MultiAction)
                ExtendedChangeIfDifferent(_Action, value, "Action")
            End Set
        End Property

        Dim WithEvents _UpActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
        Public Property UpActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
            Get
                Return _UpActions
            End Get
            Set(value As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel))
                Dim OldValue = _UpActions
                If ChangeIfDifferent(_UpActions, value) Then
                    OnExtendedPropertyChanged("UpActions", OldValue, value) 'WithEvents Property
                End If
            End Set
        End Property
        Private Sub UpActions_ItemCreating(sender As Object, e As ViewModelCollectionItemCreatingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _UpActions.ItemCreating
            e.ViewModel = New MultiActionSubActionViewModel(e.Item)
        End Sub
        Private Sub UpActions_ItemDisposing(sender As Object, e As ViewModelCollectionItemDisposingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _UpActions.ItemDisposing
        End Sub

        Dim WithEvents _DownActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
        Public Property DownActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
            Get
                Return _DownActions
            End Get
            Set(value As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel))
                Dim OldValue = _DownActions
                If ChangeIfDifferent(_DownActions, value) Then
                    OnExtendedPropertyChanged("DownActions", OldValue, value) 'WithEvents Property
                End If
            End Set
        End Property
        Private Sub DownActions_ItemCreating(sender As Object, e As ViewModelCollectionItemCreatingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _DownActions.ItemCreating
            e.ViewModel = New MultiActionSubActionViewModel(e.Item)
        End Sub
        Private Sub DownActions_ItemDisposing(sender As Object, e As ViewModelCollectionItemDisposingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _DownActions.ItemDisposing
        End Sub

        Dim WithEvents _LeftActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
        Public Property LeftActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
            Get
                Return _LeftActions
            End Get
            Set(value As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel))
                Dim OldValue = _LeftActions
                If ChangeIfDifferent(_LeftActions, value) Then
                    OnExtendedPropertyChanged("LeftActions", OldValue, value) 'WithEvents Property
                End If
            End Set
        End Property
        Private Sub LeftActions_ItemCreating(sender As Object, e As ViewModelCollectionItemCreatingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _LeftActions.ItemCreating
            e.ViewModel = New MultiActionSubActionViewModel(e.Item)
        End Sub
        Private Sub LeftActions_ItemDisposing(sender As Object, e As ViewModelCollectionItemDisposingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _LeftActions.ItemDisposing
        End Sub

        Dim WithEvents _RightActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
        Public Property RightActions As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)
            Get
                Return _RightActions
            End Get
            Set(value As ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel))
                Dim OldValue = _RightActions
                If ChangeIfDifferent(_RightActions, value) Then
                    OnExtendedPropertyChanged("RightActions", OldValue, value) 'WithEvents Property
                End If
            End Set
        End Property
        Private Sub RightActions_ItemCreating(sender As Object, e As ViewModelCollectionItemCreatingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _RightActions.ItemCreating
            e.ViewModel = New MultiActionSubActionViewModel(e.Item)
        End Sub
        Private Sub RightActions_ItemDisposing(sender As Object, e As ViewModelCollectionItemDisposingEventArgs(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)) Handles _RightActions.ItemDisposing
        End Sub

        Dim _CurrentSelectionIndex As Integer = -1
        Public Property CurrentSelectionIndex As Integer
            Get
                Return _CurrentSelectionIndex
            End Get
            Set(value As Integer)
                If ExtendedChangeIfDifferent(_CurrentSelectionIndex, value, "CurrentSelectionIndex") Then
                    UpdateSelection()
                End If
            End Set
        End Property

        Dim _CurrentSelectionDirection As Direction
        Public Property CurrentSelectionDirection As Direction
            Get
                Return _CurrentSelectionDirection
            End Get
            Set(value As Direction)
                If ExtendedChangeIfDifferent(_CurrentSelectionDirection, value, "CurrentSelectionDirection") Then
                    UpdateSelection()
                End If
            End Set
        End Property

        <Dependency("CurrentSelectionIndex", "CurrentSelectionDirection")>
        Public ReadOnly Property CurrentSelectionDirectionIsUp As Boolean
            Get
                Return CurrentSelectionIndex <> -1 AndAlso CurrentSelectionDirection = Direction.Up
            End Get
        End Property

        <Dependency("CurrentSelectionIndex", "CurrentSelectionDirection")>
        Public ReadOnly Property CurrentSelectionDirectionIsDown As Boolean
            Get
                Return CurrentSelectionIndex <> -1 AndAlso CurrentSelectionDirection = Direction.Down
            End Get
        End Property

        <Dependency("CurrentSelectionIndex", "CurrentSelectionDirection")>
        Public ReadOnly Property CurrentSelectionDirectionIsLeft As Boolean
            Get
                Return CurrentSelectionIndex <> -1 AndAlso CurrentSelectionDirection = Direction.Left
            End Get
        End Property

        <Dependency("CurrentSelectionIndex", "CurrentSelectionDirection")>
        Public ReadOnly Property CurrentSelectionDirectionIsRight As Boolean
            Get
                Return CurrentSelectionIndex <> -1 AndAlso CurrentSelectionDirection = Direction.Right
            End Get
        End Property

        Public Sub New()
            MyBase.New(True)
            If IsInDesignMode Then
                SetData(DebugData.DebugMultiAction)
                CurrentSelectionDirection = Direction.Up
                CurrentSelectionIndex = 0
                UpActions.ViewModels(0).IsSelected = True
            End If
        End Sub

        Public Sub SetData(NewAction As KeyBinding.Actions.Button.MultiAction)
            Action = NewAction
            UpActions = New ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)(New ObservableCollectionSource(Of KeyBinding.Actions.Button.MultiActionSubAction)(Action.UpActions))
            UpActions.SynchronizeWithList(Action.UpActions)
            DownActions = New ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)(New ObservableCollectionSource(Of KeyBinding.Actions.Button.MultiActionSubAction)(Action.DownActions))
            DownActions.SynchronizeWithList(Action.DownActions)
            LeftActions = New ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)(New ObservableCollectionSource(Of KeyBinding.Actions.Button.MultiActionSubAction)(Action.LeftActions))
            LeftActions.SynchronizeWithList(Action.LeftActions)
            RightActions = New ViewModelCollection(Of KeyBinding.Actions.Button.MultiActionSubAction, MultiActionSubActionViewModel)(New ObservableCollectionSource(Of KeyBinding.Actions.Button.MultiActionSubAction)(Action.RightActions))
            RightActions.SynchronizeWithList(Action.RightActions)
        End Sub

        Private Sub UpdateSelection()
            For Each i In ActionsByDirection()
                If CurrentSelectionIndex = -1 OrElse i.Key <> CurrentSelectionDirection Then
                    For Each j In i.Value
                        j.IsSelected = False
                    Next
                Else
                    Dim Index = 0
                    For Each j In i.Value
                        j.IsSelected = (Index = CurrentSelectionIndex)
                        Index += 1
                    Next
                End If
            Next
        End Sub

        Public Function ActionsByDirection() As Dictionary(Of Direction, IList(Of MultiActionSubActionViewModel))
            Return New Dictionary(Of Direction, IList(Of MultiActionSubActionViewModel))() From _
            {
                {Direction.Up, UpActions.ViewModels}, _
                {Direction.Down, DownActions.ViewModels}, _
                {Direction.Left, LeftActions.ViewModels}, _
                {Direction.Right, RightActions.ViewModels}
            }
        End Function

    End Class

End Namespace
